import React, { useCallback, useState } from 'react';
import { DEFAULT_POPOVER_WIDTH } from '../../../constants';
import { getAutoPlacing, getRect, isIE } from './helpers';
import { Arrow, Body, Container, Content } from './styles';
export var Popover = function (_a) {
    var placing = _a.placing, isOpen = _a.isOpen, children = _a.children, anchorElement = _a.anchorElement, width = _a.width, offset = _a.offset, className = _a.className, disableAutoPlacing = _a.disableAutoPlacing;
    var _b = useState(0), containerWidth = _b[0], setContainerWidth = _b[1];
    var containerRef = useCallback(function (node) {
        setContainerWidth((node === null || node === void 0 ? void 0 : node.clientWidth) || DEFAULT_POPOVER_WIDTH);
    }, []);
    if (isOpen) {
        var rect = getRect(anchorElement);
        var autoPlacing = disableAutoPlacing
            ? placing
            : getAutoPlacing(rect, placing, width || containerWidth);
        return (React.createElement(Container, { offset: offset, width: width, placing: autoPlacing, rect: rect, className: className, ref: containerRef },
            React.createElement(Body, { placing: autoPlacing },
                React.createElement(Arrow, { placing: autoPlacing }),
                React.createElement(Content, null, children))));
    }
    if (isIE()) {
        var rect = getRect(null);
        var autoPlacing = getAutoPlacing(rect, placing, width || containerWidth);
        return (React.createElement(Container, { offset: -1, width: 0, placing: autoPlacing, rect: rect, className: className }));
    }
    return null;
};
