var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useState, useEffect, useCallback, useRef } from 'react';
import cx from 'clsx';
import { Icon } from "../../elements";
import { Checkbox } from '../Checkbox';
import { DropdownHeader, DropdownHeaderArrowWrapper, DropdownHeaderTitle, DropdownItem, DropdownItemWrapper, DropdownWrapper, DropdownDivider, DropdownMultiItemWrapper, DropdownCustomTriggerWrapper, } from './styles';
var defaultWrapper = function (_a) {
    var children = _a.children;
    return React.createElement(React.Fragment, null, children);
};
export var Dropdown = function (_a) {
    var children = _a.children, className = _a.className, color = _a.color, compact = _a.compact, _b = _a.direction, direction = _b === void 0 ? 'right' : _b, autoWidth = _a.autoWidth, disabled = _a.disabled, dropup = _a.dropup, hideActive = _a.hideActive, inverted = _a.inverted, onClear = _a.onClear, onClick = _a.onClick, _c = _a.maxHeight, maxHeight = _c === void 0 ? '204px' : _c, // 6 standard items;
    options = _a.options, placeholder = _a.placeholder, renderItem = _a.renderItem, value = _a.value, text = _a.text, multi = _a.multi, _d = _a.offset, offset = _d === void 0 ? '0' : _d, fluid = _a.fluid, _e = _a.itemsListWrapper, ItemsListWrapper = _e === void 0 ? defaultWrapper : _e;
    var _f = useState(false), open = _f[0], setOpen = _f[1];
    var ref = useRef(null);
    var handleHeaderClick = function () { return setOpen(function (prevOpen) { return !prevOpen; }); };
    var hasCustomTrigger = !!children;
    var hasValue = Array.isArray(value)
        ? value.length === 0
        : !!value || value === 0;
    var isOpen = open && options.length > 0;
    var dropdownOptions = options.map(function (props, idx) {
        var _a = props, label = _a.label, render = _a.render, itemValue = _a.value, itemOnClick = _a.onClick, as = _a.as, _b = _a.itemWrapper, ItemWrapper = _b === void 0 ? defaultWrapper : _b, rest = __rest(_a, ["label", "render", "value", "onClick", "as", "itemWrapper"]);
        var handleClick = function (e) {
            if (itemOnClick) {
                itemOnClick(e); // Maybe we should pass setOpen as a param
                return;
            }
            onClick === null || onClick === void 0 ? void 0 : onClick(e, props);
            if (multi) {
                e.preventDefault();
                return;
            }
            setOpen(false);
        };
        var active = itemValue !== undefined && itemValue === value;
        if (hideActive && active) {
            return null;
        }
        var contents;
        if (render) {
            contents = render(__assign(__assign({}, props), { active: active }));
        }
        else if (renderItem) {
            contents = renderItem(__assign(__assign({}, props), { active: active }));
        }
        else {
            contents = React.createElement("span", { key: label }, label);
        }
        if (multi) {
            var checked = !!label && value.includes(itemValue);
            contents = (React.createElement(DropdownMultiItemWrapper, { key: label },
                contents,
                ' ',
                itemValue && React.createElement(Checkbox, { checked: checked, color: "primary" })));
        }
        switch (as) {
            case 'divider':
                return React.createElement(DropdownDivider, { key: "divider-" + idx });
            default:
                return (React.createElement(ItemWrapper, { key: label },
                    React.createElement(DropdownItem, __assign({ active: active, onClick: handleClick }, rest), contents)));
        }
    });
    var handleClear = useCallback(function (e) {
        if (!onClear || !hasValue) {
            return;
        }
        e.preventDefault();
        e.stopPropagation();
        onClear();
    }, [onClear, hasValue]);
    var handleClickOut = useCallback(function (e) {
        var _a;
        if ((_a = ref.current) === null || _a === void 0 ? void 0 : _a.contains(e.target)) {
            return;
        }
        setOpen(false);
    }, []);
    // Close on click outside
    useEffect(function () {
        document.addEventListener('mousedown', handleClickOut, false);
        return function () {
            return document.removeEventListener('mousedown', handleClickOut, false);
        };
    }, [handleClickOut]);
    // @todo multi select header
    var trigger;
    if (hasCustomTrigger) {
        if (typeof children === 'function') {
            trigger = children({ open: open, onClick: handleHeaderClick });
        }
        else {
            trigger = (React.createElement(React.Fragment, null, React.Children.map(children, function (child) {
                if (!child) {
                    return null;
                }
                // Ensure only valid elements are cloned
                if (!React.isValidElement(child)) {
                    return (React.createElement(DropdownCustomTriggerWrapper, { onClick: disabled ? undefined : handleHeaderClick }, child));
                }
                return React.cloneElement(child, {
                    onClick: disabled ? undefined : handleHeaderClick,
                    disabled: disabled,
                });
            })));
        }
    }
    else {
        var selectedValue = options.find(function (o) { return o.value === value; });
        var iconColor = color && (inverted ? color : 'white');
        trigger = (React.createElement(DropdownHeader, { onClick: disabled ? undefined : handleHeaderClick, isOpen: isOpen, compact: compact, dropup: dropup, color: color, fluid: fluid, inverted: inverted, disabled: disabled },
            React.createElement(DropdownHeaderTitle, { showPlaceholder: !text && !hasValue }, text ? text : hasValue ? selectedValue === null || selectedValue === void 0 ? void 0 : selectedValue.label : placeholder),
            React.createElement(DropdownHeaderArrowWrapper, { compact: compact, onClick: handleClear }, hasValue && !!onClear ? (React.createElement(Icon, { name: "times", size: "medium", color: iconColor })) : (React.createElement(Icon, { name: dropup ? 'caret-up' : 'caret-down', size: "medium", color: iconColor })))));
    }
    return (React.createElement(DropdownWrapper, { className: cx(className, { open: isOpen }), customTrigger: hasCustomTrigger, compact: compact, fluid: fluid, ref: ref },
        trigger,
        isOpen && (React.createElement(DropdownItemWrapper, { maxHeight: maxHeight, direction: direction, customTrigger: hasCustomTrigger, dropup: dropup, autoWidth: autoWidth, offset: offset },
            React.createElement(ItemsListWrapper, null, dropdownOptions)))));
};
