import React from 'react';
import { HiroColors } from "../../../types";
export interface DropdownItemProps extends Omit<React.HTMLProps<HTMLDivElement>, 'as' | 'ref' | 'label'> {
    active?: boolean;
    value?: any;
    autoHeight?: boolean;
    onClick?: (e: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
    label?: string | number;
    render?: (props: DropdownItemProps) => React.ReactNode;
    divider?: boolean;
    disabled?: boolean;
    as?: 'divider' | 'header' | 'option';
    itemWrapper?: React.FC;
}
export interface DropdownProps {
    renderItem?: (props: DropdownItemProps) => React.ReactNode;
    itemsListWrapper?: React.FC;
    onClick?: (event: React.MouseEvent<HTMLDivElement, MouseEvent>, data: DropdownItemProps) => void;
    onClear?: () => void;
    className?: string;
    value?: any;
    placeholder?: string;
    text?: string;
    options: DropdownItemProps[];
    direction?: 'left' | 'right';
    autoWidth?: boolean;
    multi?: boolean;
    compact?: boolean;
    maxHeight?: string;
    dropup?: boolean;
    color?: HiroColors;
    inverted?: boolean;
    disabled?: boolean;
    hideActive?: boolean;
    offset?: string;
    fluid?: boolean;
}
export interface DropdownRenderProps {
    open: boolean;
    onClick: () => void;
}
